import { QueryLatestValsetNonceResponse, QueryAllValsetResponse, QueryGetValsetResponse, QueryLatestValsetResponse, QueryLastEventNonceResponse, QueryListOrchestratorsResponse } from '@routerprotocol/chain-api/routerchain/attestation/query_pb';
import { Valset } from '@routerprotocol/chain-api/routerchain/attestation/valset_pb';
import { MsgSetOrchestratorAddress as Orchestrator } from '@routerprotocol/chain-api/routerchain/attestation/tx_pb';
export declare class ChainGrpcAttestationTransformer {
    static latestValsetNonce(response: QueryLatestValsetNonceResponse): QueryLatestValsetNonceResponse.AsObject;
    static allValset(response: QueryAllValsetResponse): QueryAllValsetResponse.AsObject;
    static valsetByNonce(response: QueryGetValsetResponse): {
        valset: Valset.AsObject | undefined;
    };
    static latestValset(response: QueryLatestValsetResponse): {
        valset: Valset.AsObject | undefined;
    };
    static lastEventByValidator(response: QueryLastEventNonceResponse): {
        eventNonce: number;
    };
    static listOrchestrators(response: QueryListOrchestratorsResponse): {
        orchestrator_set: Orchestrator.AsObject[];
    };
    private static getOrchestratorObject;
    private static getValsetObject;
    private static getMemberObject;
}
